Package org.optaplanner.core.impl.score.stream.drools.tri

## Class DroolsGroupingTriConstraintStream<Solution_,​NewA,​NewB,​NewC>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream<Solution_,​NewA,​NewB,​NewC>
      - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsGroupingTriConstraintStream<Solution_,​NewA,​NewB,​NewC>

- All Implemented Interfaces:
    `ConstraintStream`, `TriConstraintStream<NewA,​NewB,​NewC>`, `InnerTriConstraintStream<NewA,​NewB,​NewC>`

      public class DroolsGroupingTriConstraintStream<Solution_,​NewA,​NewB,​NewC>
      extends DroolsAbstractTriConstraintStream<Solution_,​NewA,​NewB,​NewC>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream

      `parent`

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiFunction<A,​B,​NewB> groupKeyBMapping, BiConstraintCollector<A,​B,​ResultContainer_,​NewC> collector)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping, QuadConstraintCollector<A,​B,​C,​D,​ResultContainer_,​NewC> collector)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriFunction<A,​B,​C,​NewB> groupKeyBMapping, TriConstraintCollector<A,​B,​C,​ResultContainer_,​NewC> collector)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, Function<A,​NewB> groupKeyBMapping, UniConstraintCollector<A,​ResultContainer_,​NewC> collector)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DroolsTriCondition<NewA,​NewB,​NewC,​?>` | `getCondition()` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream

      `filter, getCardinality, getFromStreamList, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong, join`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `addChildStream, buildConstraint, buildConstraintConfigurable, createRuleItemBuilders, getChildStreams, getConstraintFactory, getExpectedJustificationTypes`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.tri.InnerTriConstraintStream

      `impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.tri.TriConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, join, join, join, join, join, join, join, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                   Function<A,​NewA> groupKeyAMapping,
                                                   Function<A,​NewB> groupKeyBMapping,
                                                   UniConstraintCollector<A,​ResultContainer_,​NewC> collector)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                   BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                   BiFunction<A,​B,​NewB> groupKeyBMapping,
                                                   BiConstraintCollector<A,​B,​ResultContainer_,​NewC> collector)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                   TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                   TriFunction<A,​B,​C,​NewB> groupKeyBMapping,
                                                   TriConstraintCollector<A,​B,​C,​ResultContainer_,​NewC> collector)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                   QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                   QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping,
                                                   QuadConstraintCollector<A,​B,​C,​D,​ResultContainer_,​NewC> collector)

  - ### Method Detail

    - #### getCondition

          public DroolsTriCondition<NewA,​NewB,​NewC,​?> getCondition()

      Specified by:
        `getCondition` in class `DroolsAbstractTriConstraintStream<Solution_,​NewA,​NewB,​NewC>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`